"""
    Binary_c-python's HPC functions

    These are common to both the slurm and condor interfaces.
"""
import os

class HPC():

    def __init__(self, **kwargs):
        # don't do anything: we just inherit from this class
        return

    def joinfiles(self):
        """
        Function to load in the joinlist to an array and return it.
        """
        f = open(self.grid_options['joinlist'],'r',encoding='utf-8')
        list = f.read().splitlines()
        f.close()
        return list

    def join_from_files(self,newobj,joinfiles):
        """
        Merge the results from the list joinfiles into newobj.
        """
        for file in joinfiles:
            print("Join data in",file)
            self.merge_populations_from_file(newobj,
                                             file)
        return newobj

    def can_join(self,joinfiles,joiningfile,vb=False):
        """
        Check the joinfiles to make sure they all exist
        and their .saved equivalents also exist
        """
        vb = False # for debugging set this to True
        if os.path.exists(joiningfile):
            if vb:
                print("cannot join: joiningfile exists at {}".format(joiningfile))
            return False
        elif vb:
            print("joiningfile does not exist")
        for file in joinfiles:
            if vb:
                print("check for {}".format(file))
            if os.path.exists(file) == False:
                if vb:
                    print("cannot join: {} does not exist".format(file))
                return False
            savedfile = file + '.saved'
            if vb:
                print("check for {}".format(savedfile))
            if os.path.exists(savedfile) == False:
                if vb:
                    print("cannot join: {} does not exist".format(savedfile))
                return False

            # found both files
            if vb:
                print("found {} and {}".format(file,savedfile))

        # check for joiningfile again
        if os.path.exists(joiningfile):
            if vb:
                print("cannot join: joiningfile exists at {}".format(joiningfile))
            return False
        elif vb:
            print("joiningfile does not exist")

        if vb:
            print("returning True from can_join()")
        return True
